#define INCL_WIN
#define INCL_WINSTDBOOK
#define INCL_DOSPROCESS
#define INCL_WINSTDDRAG
#define INCL_DOSSEMAPHORES
#define INCL_GPI

#include <os2.h>
#include <stdlib.h>
#include <process.h>
#include <stdio.h>
#include <ctype.h>
#include <stdarg.h>

#include "cutter.hpp"


extern "C" {
char *SuperJPEG ( HAB hab,
                     HPS hps0,
                     PSZ pszFileName, LONG thumbW, LONG thumbH, photo_card*photo, ULONG *bmpsize, HEV hev );
}
                     
main(int argc, char **argv)
{
   char *image, *block, *target;
   int x0, y0, w, h;
   SHORT imagew, imageh;
   char *image_bytes, *block_bytes;
   ULONG image_offset, block_offset, image_row, block_row;
   BITMAPINFOHEADER2 *pbiheader;
   BITMAPFILEHEADER2* pfh;
   
   
   // 1.  㬥
   
   printf("㬥⮢: %d\n", argc);
   image=argv[1];
   x0=atoi(argv[2]);
   y0=atoi(argv[3]);
   w=atoi(argv[4]);
   h=atoi(argv[5]);
   block=argv[6];
   
   printf("⨭: %s; %d,%d - %d, %d;   %s\n", image, x0, y0, w, h, block);

   
   // 2. 㧨 室 BMP
   ULONG tempbmpsize;
   photo_card photo;
   
   char *image_data=SuperJPEG(0, 0,
                    image,
                    -1, -1,
                    &photo,
                    &tempbmpsize, 0);

   PBITMAPFILEHEADER2 pbfh2 = (PBITMAPFILEHEADER2)(image_data);

   imagew=pbfh2->bmp2.cx;
   imageh=pbfh2->bmp2.cy;
                    
   printf("ࠧ ⨭: %dx%d\n", imagew, imageh);
            
   image_row=(((24 * imagew) + 31) / 32) * 4;
   block_row=(((24 * w) + 31) / 32) * 4;
   
   
   // 3.   ⬠
   
   int cbBuffer = block_row * h;
   int bmpsize=sizeof(BITMAPFILEHEADER2)+cbBuffer;
   target = new char[bmpsize];
   
       pfh = (BITMAPFILEHEADER2*) target;
       pfh->usType = BFT_BMAP;
       pfh->cbSize = sizeof(BITMAPFILEHEADER2);
       pfh->xHotspot = 0;
       pfh->yHotspot = 0;
       pfh->offBits  = sizeof(BITMAPFILEHEADER2);  // 54


       // 2. ᮧ  䠩;

       pbiheader=&(pfh->bmp2);

       pbiheader->cbFix=sizeof(BITMAPINFOHEADER2);
       pbiheader->cx=w;
       pbiheader->cy=h;
       pbiheader->cPlanes=1;
       pbiheader->cBitCount=24;
       pbiheader->ulCompression=0;
       pbiheader->cbImage=cbBuffer;
   
   block_bytes=((char*)pfh + pfh->offBits);
   
       
   // 4. ७ 㦭    ⬠
   
   image_bytes=((char*)pbfh2 + pbfh2->offBits);


   for(int j=0; j<h; j++) {
      for(int k=0; k<w; k++) {
         image_offset=(k+x0)*3 + (j+y0)*image_row;
         block_offset=(k)*3 + (j)*block_row;

         block_bytes[block_offset]  =image_bytes[image_offset];
         block_bytes[block_offset+1]=image_bytes[image_offset+1];
         block_bytes[block_offset+2]=image_bytes[image_offset+2];

      }
   }
   
   
   // 5.  ⬠
   
         FILE *f = fopen( block, "wb" );
         fwrite(target, 1, bmpsize, f);
         fclose (f);
   
   
}


